<template>
  <mt-box padding="1.5rem" class="mt-pop-up-activite" :style="styleCss" :class="{ 'mt-afficher': afficher }">
    <mt-tag-button-activity :text="detailType.libelle" :tag-class="detailType.class" :icon="detailType.icon" />
    <div class="columns">
      <h1>{{ activite.nom }}</h1>
      <mt-pastille
        v-if="(activitesEnfants && activitesEnfants.length > 0) || activiteParent"
        class="column is-narrow mt-margin"
        is-black
        size="18px"
        ><b-icon icon="share-variant" size="is-small"></b-icon>
      </mt-pastille>
    </div>
    <mt-date-range-short
      class="is-uppercase has-text-weight-bold"
      :start="activite.dateDebut"
      :end="activite.dateFin"
    />
    <div class="is-narrow">
      <div v-if="activiteParent">
        <mt-unite class="mt-margin-unit" :organisme="activiteParent.organisme" unite-principale is-pop-up />
      </div>
      <div>
        <mt-unite
          class="mt-margin-unit"
          :organisme="activite.organisme"
          :unite-principale="!activiteParent"
          is-pop-up
        />
      </div>
      <div v-if="activitesEnfants && activitesEnfants.length > 0" class="mt-inline">
        <div v-for="(activiteEnfant, index) in activitesEnfants" :key="index">
          <mt-unite class="mt-margin-unit" :organisme="activiteEnfant.organisme" :unite-principale="false" />
        </div>
      </div>
    </div>
    <small>{{ activite.description }}</small>
    <ul>
      <li v-if="getParticipation()" class="columns">
        <label class="column is-narrow">Mon Statut</label>
        <span class="mt-statut column is-narrow">{{ getParticipation() }}</span>
      </li>
    </ul>
    <label>Gestion des participants</label>
    <div v-if="!activite.participantsGroupe || activite.participantsGroupe.length === 0">
      <ul>
        <li v-if="statutsParticipants[0]">
          <p>{{ statutsParticipants[0].statut.nom }}</p>

          <div>
            <b>{{ candidat }} / {{ dispo }}</b>
            <b-icon icon="account" class="has-text-grey-light" />
          </div>
        </li>
        <li v-if="statutsParticipants[1]">
          <p>{{ statutsParticipants[1].statut.nom }}</p>

          <div>
            <b>{{ statutsParticipants[1].participants.length }}</b>
            <b-icon icon="account" class="has-text-grey-light" />
          </div>
        </li>
        <li>
          <p>{{ activite.avancement.statut.nom }}</p>
          <div>
            <b>{{ activite.avancement.taux.nombre }} / {{ activite.avancement.taux.total }}</b>
            <b-icon icon="account" class="has-text-grey-light" />
          </div>
        </li>
      </ul>
      <mt-progress-activity class="mt-progress-activity" :activite="activite" />
      <mt-progress-pax-sub
        v-for="(effectif, index) in activite.effectifs"
        :key="index"
        progress-size="125px"
        class="mt-progress-pax"
        :pax="effectif"
      />
    </div>
    <ul>
      <li v-for="(participant, index) in activite.participantsGroupe" :key="index" class="columns">
        <mt-utilisateur class="column" :utilisateur="participant.utilisateur" />
        <span class="mt-statut column is-narrow">{{ getParticipationStatut(participant) }}</span>
      </li>
    </ul>
  </mt-box>
</template>

<script>
import MtProgressPaxSub from '~/components/activity/progress-pax-subscribed';
import MtProgressActivity from '~/components/activity/progress-users-activity';
import MtDateRangeShort from '~/components/activity/date-range-short';
import MtTagButtonActivity from '~/components/activity/tag-button-activity';
import MtBox from '~/components/base/box';
import { classResolver } from '~/components/mixins/activityMixin';
import MtUnite from '~/components/activity/unite';
import MtPastille from '~/components/base/pastille/index';
import MtUtilisateur from '~/components/pax/mt-utilisateur';

export default {
  name: 'MtPopUpActivite',
  components: {
    MtUnite,
    MtBox,
    MtTagButtonActivity,
    MtDateRangeShort,
    MtProgressActivity,
    MtProgressPaxSub,
    MtPastille,
    MtUtilisateur,
  },
  mixins: [classResolver],
  props: {
    activite: {
      type: Object,
      default: () => ({}),
    },
    activiteParent: {
      type: Object,
      default: () => ({}),
    },
    activitesEnfants: {
      type: Array,
      default: () => [],
    },
    styleCss: {
      type: Object,
      default: () => ({}),
    },
    afficher: {
      type: Boolean,
      default: false,
    },
  },
  data() {
    return {
      statutsParticipants: {},
      statutsParticipantsLoaded: false,
      candidat: 0,
      dispo: 0,
    };
  },

  computed: {
    detailType() {
      return this.resolveTypeActivite(this.activite, 'mt-background-type-');
    },
  },
  watch: {
    afficher: {
      handler(newValue) {
        if (newValue) {
          this.loadStatutsParticipant();
        }
      },
      immediate: true,
    },
  },
  methods: {
    getParticipation() {
      if (this.activite.participants[0] && this.activite.participants[0].dernierAvancement.choix.statut) {
        return this.activite.participants[0].dernierAvancement.choix.statut.code;
      }
      return null;
    },
    getParticipationStatut(participant) {
      if (participant.statut) {
        return participant.statut.code;
      }
      return null;
    },
    async loadStatutsParticipant() {
      if (!this.statutsParticipantsLoaded) {
        this.statutsParticipantsLoaded = true;
        this.statutsParticipants = await this.$api.activites.detailsPopUp(this.activite.id);
        for (let i = 0; i < this.statutsParticipants[0].participants.length; i += 1) {
          if (this.statutsParticipants[0].participants[i].statut !== null) {
            this.candidat += 1;
          } else {
            this.dispo += 1;
          }
        }
      }
    },
  },
};
</script>

<style scoped lang="scss">
@import '~/assets/css/_variables';
.mt-box {
  display: none;
  width: 43ch;
  z-index: 100;
  color: #3a3a3a;
  margin-top: 1rem;
  border-radius: $border-radius;
  box-shadow: 0 2px 4px -1px rgba(95, 95, 95, 0.5), 0 0 3px rgba(95, 95, 95, 0.25);
  position: fixed;

  &.mt-afficher {
    display: block;
  }

  h1 {
    color: $grey-dark;
    font-size: 1.125rem;
    font-weight: bold;
    line-height: 1.17;
    padding: 0.5em 0;
    white-space: normal;
  }

  /deep/ .mt-unit {
    font-size: 0.75rem;
  }

  /deep/ .mt-unit-parent {
    font-size: 0.75rem;

    .mdi-24px.mdi::before {
      font-size: 1.5em;
    }
  }

  /deep/ .mt-date-range {
    font-size: 0.875rem;
    color: $grey;
  }

  /deep/ .mt-type-activite {
    font-size: 0.75rem;
    margin-left: -0.5em;

    .mdi-24px.mdi::before {
      font-size: 1.5em;
    }
  }

  small {
    white-space: normal;
    font-size: 0.75rem;
    max-height: 4.5em;
    overflow: hidden;
    margin: 0.5em 0;
    display: block;
  }

  /deep/ .progress {
    height: 0.5rem;
    background-color: #efefef;
  }

  /deep/ .progress-wrapper:not(:last-child) {
    margin-bottom: 0;
  }
}
label {
  font-weight: bold;
  color: #5f5f5f;
  font-size: 0.875rem;
  margin: 0;
  padding: 0 1em 0 0;
}
ul {
  margin: 0.3em;
}
li {
  display: flex;
  align-items: center;
  justify-content: space-between;
  font-size: 0.8rem;
  margin: 0.2em -0.2;

  div {
    display: flex;
    align-items: center;

    b {
      font-weight: bold;
      color: #5f5f5f;
      font-size: 0.8rem;
      padding-right: 0.2em;
    }
  }
}
.mt-margin {
  margin: 1em;
}
.mt-inline {
  display: inline-flex;
}
.mt-margin-unit {
  margin-bottom: -0.7em;
}
.grid-effectif {
  margin: 0;
}
/deep/ .mt-font {
  font-size: 0.6em !important;
}
.mt-progress-activity {
  padding-bottom: 0.5em;
}
</style>
